pipeline {
    agent any

    stages {
        stage('Upload Key') {
            agent any
            steps {
                script {
                    // Uploads file via master node and stases it for other nodes to access
                    def inputFile = input message: 'Upload file', parameters: [file(name: "Cypress.txt")]
                    writeFile file: '${workspace}/Cypress.txt',  text: "Cypress.txt"
                    //new hudson.FilePath(new File("")).copyFrom(inputFile)
                    //inputFile.delete()
                }
                stash name: 'Cypress.txt', includes: "Cypress.txt"
            }
        }
        stage('Register') {
            steps {
                ws(sanitizedWorkspaceName) {
                    echo "Registering"
                    unstash 'Cypress.txt'
                }
            }
        }
        stage('Tests') {
            steps {
                script {
                    try {

                        def exitCode

                        parallel(
                            runAndroidTests: {
            
                                    exitCode = sh script: "npx cypress run", returnStatus: true
                                }                        
                        )
                        if (exitCode == 0) {
                            sh "echo exitCode:" + exitCode
                            currentBuild.result = "SUCCESS"
                        } else if (exitCode == 1) {
                            sh "echo exitCode:" + exitCode
                            currentBuild.result = "UNSTABLE"
                        } else {
                            sh "echo exitCode:" + exitCode
                            currentBuild.result = "SUCCESS"
                        }
                    } catch (e) {} finally {
                        stage('Report') {
                            archiveArtifacts artifacts: 'cypress/videos/**.mp4', fingerprint: true
                        }
                    }
                }
            }
        }
    }
}
